SystemOrganization addCategory: #'Glamour-Morphic-Renderer'!

PluggableShoutMorph subclass: #GLMPluggableShoutMorph
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMPluggableShoutMorph commentStamp: 'tg 4/15/2010 17:53' prior: 0!
We subclass the default PluggableShoutMorph just to raise the proper announcements when the text or when the selection changes.!

!GLMPluggableShoutMorph methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2010 18:00'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMPluggableShoutMorph methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2010 17:59'!
selectFrom: start to: stop
	| result |
	result := super selectFrom: start to: stop.
	self announcer announce: (GLMSelectedTextChanged new start: start; end: stop).
	^ result! !

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicRenderer commentStamp: 'tg 4/1/2010 07:11' prior: 0!
This is the class responsible for the binding to Morphic.

| browser |
browser := GLMTabulator new.
browser column: #one; column: #two.

browser transmit to: #one; andShow: [:a | a list.].
browser transmit to: #two; from: #one; andShow: [ :a |
	a text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'tg 8/24/2010 21:51'!
open: aRenderable
	window := GLMMorphicWindowRenderer render: aRenderable from: self.
	^ window openInWorld! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderAccordionCompositePresentation: aCompositePresentation
	^ GLMMorphicAccordionRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:51'!
renderAccumulator: aBrowser 
	^ GLMMorphicAccumulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/20/2011 21:53'!
renderActionListPresentation: anActionListPresentation 
	| container buttonModel button |
	container := GLMMorphic containerMorph.
	anActionListPresentation allActions withIndexDo: 
		[ :each :index | 
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: anActionListPresentation.
		buttonModel glamourAction: each.
		button := PluggableButtonMorph 
			on: buttonModel
			getState: nil
			action: #execute
			label: #buttonLabel.
		container 
			addMorph: button
			fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 1 @ 0)
					offsets: (0 @ ((index - 1) * 24) corner: 0 @ (index * 24))) ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/3/2010 13:56'!
renderDiffPresentation: aPresentation
	^ GLMMorphicDiffRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'VeronicaUquillas 5/26/2010 13:44'!
renderDropDownListPresentation: aDropListPresentation
	| listModel |

	listModel:= GLMDropListModel new glamourPresentation: aDropListPresentation.
	"When the morph changes, we want to update the glamour model"
	listModel announcer on: GLMDropDownListMorphSelectionChanged do: [ :ann | 	
		aDropListPresentation selection: ann selectionValue ].
	
	^(MorphDropListMorph
			on: listModel
			list: #list
			selected: #selectionIndex
			changeSelected: #selectionIndex:
			useIndex: true )
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 1/2/2011 18:58'!
renderExpander: aBrowser 
	^ GLMMorphicExpanderRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:51'!
renderFinder: aBrowser 
	^ GLMMorphicFinderRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/20/2011 21:53'!
renderInputPresentation: aPresentation 
	
	| morph |
	self flag: 'hook the cuis editor'.
	morph := GLMMorphic containerMorph.
	^ morph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 10/28/2010 19:55'!
renderLabelPresentation: aLabelPresentation 
	| morph | 
	morph := (LabelMorph contents: aLabelPresentation formatedDisplayValue) 
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			font: StandardFonts haloFont;
			yourself.
	^morph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:14'!
renderListPresentation: aListPresentation 
	^ GLMMorphicListRenderer render: aListPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:12'!
renderListingPresentation: aPresentation 
	^ GLMMorphicListingRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/13/2011 13:46'!
renderMagrittePresentation: aMagrittePresentation 
	^ GLMMorphicMagritteRenderer render: aMagrittePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/23/2010 00:22'!
renderMondrianPresentation: aPresentation
	^ GLMMorphicMondrianRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'lr 11/7/2009 11:42'!
renderMorphPresentation: aMorphPresentation 
	^ aMorphPresentation displayValue! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 21:51'!
renderPane: aPane 
	^ GLMMorphicPaneRenderer render: aPane from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderStackedVerticallyCompositePresentation: aCompositePresentation
	^ GLMMorphicVerticallyStackedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderStacker: aBrowser 
	^ GLMMorphicStackerRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:33'!
renderTabbedCompositePresentation: aCompositePresentation
	^ GLMMorphicTabbedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:15'!
renderTablePresentation: aPresentation 
	^ GLMMorphicTableRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderTabulator: aBrowser 
	^ GLMMorphicTabulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 20:22'!
renderTextPresentation: aTextPresentation 
	^ GLMMorphicTextRenderer render: aTextPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:16'!
renderTreePresentation: aPresentation 
	^ GLMMorphicTreeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window
	^ window! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window: anObject
	window := anObject! !

StandardWindow subclass: #GLMSystemWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMSystemWindow methodsFor: 'building' stamp: 'tg 9/23/2010 21:48'!
buildWindowMenu
	| actions aMenu |
	actions := self model allActions select: [:each | each hasTitle and: [each hasIcon not]].
	^ actions isEmpty
		ifTrue: [ super buildWindowMenu ]
		ifFalse: [
			aMenu := self theme newMenuIn: self for: self.
			actions
				inject: aMenu
				into: [ :menu :action |
					menu
						add: action title target: action selector: #actOn: argument: self model;
						yourself ] ]! !

!GLMSystemWindow methodsFor: 'as yet unclassified' stamp: 'tg 1/31/2010 00:26'!
delete
	self model unregisterFromAllAnnouncements.
	super delete! !

!GLMSystemWindow methodsFor: 'building' stamp: 'tg 11/5/2009 15:56'!
extent: aPoint 
	super extent: aPoint.
	self fullBounds.
	self refreshHorizontalScollbars.! !

!GLMSystemWindow methodsFor: 'building' stamp: 'tg 3/4/2010 23:23'!
refreshHorizontalScollbars
	self flag: 'this was somehow needed when the magritte form was embedded in a scroll pane'
"	self allMorphsDo: 
		[ :morph | 
		(morph isKindOf: GLMScrollPaneForHResize) ifTrue: [ 
			morph scroller submorphs anyOne width: morph scroller width - 20 ] ]"! !

TabGroupMorph subclass: #LazyTabGroupMorph
	instanceVariableNames: 'onPageIndexChange announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 21:01'!
addLazyPage: aBlock label: aStringOrMorph
	self addLazyPage: aBlock label: aStringOrMorph toolbar: nil! !

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 22:03'!
addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar
	self addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar collapsable: false! !

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 22:02'!
addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar collapsable: aBoolean
	| newPage label innerLabel |
	newPage := LazyTabPage new.
	newPage
		lazyPageMorphCreation: aBlock; 
		labelMorph: aStringOrMorph; 
		toolbar: aToolbar.
	innerLabel := aStringOrMorph isMorph
		ifTrue: [aStringOrMorph]
		ifFalse: [(self theme buttonLabelForText: aStringOrMorph)
					font: self font;
					vResizing: #shrinkWrap;
					hResizing: #shrinkWrap].
	label := aBoolean 
			ifTrue: [UITheme builder newRow: { 
				innerLabel .
				UITheme builder
					newCloseControlFor: nil
					action: [self removePage: newPage]
					help: nil}]
			ifFalse: [innerLabel].
	self 
		addPage: newPage
		label: label! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:10'!
announcer
	^ announcer ifNil: [announcer := Announcer new]! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/22/2011 21:03'!
pageAt: index
	^ (self pages at: index ) actualPageMorph! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/23/2011 00:25'!
removePage: aPage
	| removedPageIndex |
	removedPageIndex := self pages indexOf: aPage.
	super removePage: aPage.
	self announcer announce: (LazyTabPageRemoved new tabs: self; page: aPage; pageIndex: removedPageIndex)! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/23/2011 00:23'!
removePageIndex: anInteger
	self removePage: (self pages at: anInteger)! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/23/2011 00:25'!
updatePageIndex: index
	"Change to the given page index."

	| p oldPage |
	
	index = 0 ifTrue: [^ self].
	oldPage := self tabSelectorMorph selectedTab.
	p := self pageMorph.
	p isNil
		ifTrue: [self contentMorph addMorph: (self pageAt: index)]
		ifFalse: [self contentMorph
				replaceSubmorph: p
				by: (self pageAt: index)].
	self pageMorph layoutChanged.
	self adoptPaneColor: (self owner ifNil: [self]) paneColor.
	self announcer announce: (LazyTabPageChanged new tabs: self; page: (self pages at: index); oldPage: oldPage; pageIndex: index)! !

Announcement subclass: #GLMActionAnnouncement
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMActionAnnouncement classSide methodsFor: 'instance creation' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	^self new action: anAction; yourself! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action
	^action! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	action := anAction! !

GLMActionAnnouncement subclass: #GLMKeyStroke
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMActionAnnouncement subclass: #GLMMenuInvoked
	instanceVariableNames: 'menuMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMenuInvoked classSide methodsFor: 'as yet unclassified' stamp: 'jre 7/31/2009 15:24'!
action: anAction on: aMenuMorph 
	^self new initializeAction: anAction on: aMenuMorph! !

!GLMMenuInvoked methodsFor: 'initialization' stamp: 'jre 7/31/2009 15:43'!
initializeAction: anAction on: aMenuMorph 
	self action: anAction.
	menuMorph := aMenuMorph! !

!GLMMenuInvoked methodsFor: 'accessing' stamp: 'jre 7/31/2009 15:43'!
menuMorph
	^menuMorph! !

GLMActionAnnouncement subclass: #GLMMenuItemSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

Announcement subclass: #GLMDropDownListMorphSelectionChanged
	instanceVariableNames: 'selectionValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 20:15'!
selectionValue
	^ selectionValue! !

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 20:15'!
selectionValue: anObject
	selectionValue := anObject! !

Announcement subclass: #GLMSelectedTextChanged
	instanceVariableNames: 'start end selectedText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
end
	^ end! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
end: anObject
	end := anObject! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
selectedText
	^ selectedText! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
selectedText: anObject
	selectedText := anObject! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
start
	^ start! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
start: anObject
	start := anObject! !

Announcement subclass: #GLMTreeMorphSelectionChanged
	instanceVariableNames: 'selectionValue selectionPathValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:56'!
selectionPathValue
	^ selectionPathValue! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:56'!
selectionPathValue: anObject
	selectionPathValue := anObject! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:54'!
selectionValue
	^ selectionValue! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:54'!
selectionValue: anObject
	selectionValue := anObject! !

Announcement subclass: #GLMTreeMorphStrongSelectionChanged
	instanceVariableNames: 'strongSelectionValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMTreeMorphStrongSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:58'!
strongSelectionValue
	^ strongSelectionValue! !

!GLMTreeMorphStrongSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:58'!
strongSelectionValue: anObject
	strongSelectionValue := anObject! !

Announcement subclass: #LazyTabPageAnnouncement
	instanceVariableNames: 'page tabs pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
page
	^ page! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
page: anObject
	page := anObject! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/23/2011 00:23'!
pageIndex
	^ pageIndex! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/23/2011 00:23'!
pageIndex: anObject
	pageIndex := anObject! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
tabs
	^ tabs! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
tabs: anObject
	tabs := anObject! !

LazyTabPageAnnouncement subclass: #LazyTabPageChanged
	instanceVariableNames: 'oldPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!LazyTabPageChanged methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
oldPage
	^ oldPage! !

!LazyTabPageChanged methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
oldPage: anObject
	oldPage := anObject! !

LazyTabPageAnnouncement subclass: #LazyTabPageRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMAction subclass: #GLMMorphicAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAction methodsFor: 'testing' stamp: 'tg 9/24/2010 15:36'!
worksWithMorphic
	^ true! !

!GLMMorphicAction methodsFor: 'testing' stamp: 'tg 9/24/2010 15:36'!
worksWithSeaside
	^ false! !

BorderedMorph subclass: #LazyTabPage
	instanceVariableNames: 'actualPageMorph labelMorph lazyPageMorphCreation toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 18:11'!
actualPageMorph
	^ actualPageMorph ifNil: [actualPageMorph := self lazyPageMorphCreation value]! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
actualPageMorph: anObject
	actualPageMorph := anObject! !

!LazyTabPage methodsFor: 'testing' stamp: 'TudorGirba 1/22/2011 22:26'!
isRendered
	^ actualPageMorph notNil! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
labelMorph
	^ labelMorph! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
labelMorph: anObject
	labelMorph := anObject! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 18:11'!
lazyPageMorphCreation
	^ lazyPageMorphCreation! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 18:11'!
lazyPageMorphCreation: anObject
	lazyPageMorphCreation := anObject! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 20:50'!
toolbar
	^ toolbar! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 20:50'!
toolbar: anObject
	toolbar := anObject! !

MorphTreeNodeModel subclass: #GLMExpanderContentsNodeModel
	instanceVariableNames: 'containerNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMExpanderContentsNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 16:49'!
containerNode
	^ containerNode! !

!GLMExpanderContentsNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 16:49'!
containerNode: anObject
	containerNode := anObject! !

!GLMExpanderContentsNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 1/6/2011 01:09'!
elementColumn
	| row morph |
	
	morph := GLMMorphicWidgetRenderer new	renderPaneWithoutTitle: self containerNode item.
	morph 
		borderStyle: (UITheme current buttonSelectedBorderStyleFor: morph).

	row := OrderedCollection with: morph.
	^ UITheme current newRowIn: World for: row! !

!GLMExpanderContentsNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 14:09'!
icon
	^ nil! !

MorphTreeNodeModel subclass: #GLMExpanderLabelNodeModel
	instanceVariableNames: 'containerTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMExpanderLabelNodeModel classSide methodsFor: 'instance creation' stamp: 'TudorGirba 1/2/2011 21:16'!
with: anObject in: aTreeModel
	^ (self with: anObject) containerTree: aTreeModel; yourself! !

!GLMExpanderLabelNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 1/5/2011 17:24'!
childrenItems
	^ OrderedCollection 
		with: ((GLMExpanderContentsNodeModel with: (self->self item)) containerNode: self)! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 13:53'!
containerTree
	^ containerTree! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 13:53'!
containerTree: anObject
	containerTree := anObject! !

!GLMExpanderLabelNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 1/5/2011 10:50'!
contents
	^ self childrenItems! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 14:10'!
displayText
	^ UITheme current 
		newTextIn: World
		text: (self item presentations titleValue ifNil: ['noname']) ! !

!GLMExpanderLabelNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 1/5/2011 23:21'!
elementColumn
	| row tags tagsFilter |
	row := OrderedCollection with: (self displayText).
	
"	tags:= self containerTree glamourPresentation tagsFor: self item to: #show.
	tagsFilter := self containerTree glamourPresentation tagsFor: self item to: #filter.
	tags withIndexDo:[ :each :index | 
			row addLast: (self buttonForTag: each 
									  filter: (tagsFilter at: index ifAbsentPut:[ each ])) ].
"	^ (UITheme current newRowIn: World for: row) fillStyle: Color veryLightGray! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 14:20'!
icon
	^ nil! !

MorphTreeNodeModel subclass: #GLMTreeMorphNodeModel
	instanceVariableNames: 'contents containerTree onSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'VeronicaUquillas 6/15/2010 11:13'!
buttonForTag: each filter: filter
	| button |

	button := GLMMorphic 
		togglingButtonLabelled: each
		pressed: (self containerTree shouldFilterByTag: filter)
		style: self containerTree glamourPresentation tagsStyle.
	button
		target: self;
		actionSelector: #toggleFilteringByTag:;
		arguments: (Array with: filter).
	^ button! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 4/18/2010 23:19'!
childrenItems
	^ (self containerTree glamourPresentation childrenValueOf: self item atLevel: self path size) ifNil: [OrderedCollection new]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree
	^ containerTree! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree: anObject
	containerTree := anObject! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 11/30/2009 02:10'!
contents
	| allContents |
	^ contents ifNil: 
		[ allContents := self childrenItems collect: [ :d | 
			(self class with: d)
				parentNode: self;
				containerTree: self containerTree;
				yourself ].
		contents := allContents select: [ :each | each shouldBeDisplayed ] ]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 00:59'!
displayText
	^ UITheme current 
		newTextIn: World
		text: (self containerTree glamourPresentation formatedDisplayValueOf: self item) ! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'VeronicaUquillas 11/19/2009 22:44'!
elementColumn
	| row tags tagsFilter |
	row := OrderedCollection with: self displayText.
	tags:= self containerTree glamourPresentation tagsFor: self item to: #show.
	tagsFilter := self containerTree glamourPresentation tagsFor: self item to: #filter.
	tags withIndexDo:[ :each :index | 
			row addLast: (self buttonForTag: each 
									  filter: (tagsFilter at: index ifAbsentPut:[ each ])) ].
	^ UITheme current newRowIn: World for: row! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'alain.plantec 9/8/2009 14:37'!
enabled
	^ true! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/16/2009 23:39'!
executeMenuAction: anAction
	self containerTree announce: (GLMMenuItemSelected action: anAction)! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 11/2/2009 01:19'!
expandParentPath
"	self openItemPath: anArray"
	self containerTree changed: {#roots. #openItemPath}, (self path collect: [:each | each item]).! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:54'!
icon
	^ self containerTree glamourPresentation iconFor: self item! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/8/2009 21:09'!
keyStroke: aCharacter from: aTreeMorph 
	^ false
! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 1/17/2010 13:23'!
menu: aMenuMorph shifted: b 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self containerTree allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode
	^ parentNode! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode: aNode
	parentNode := aNode
	! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 4/15/2010 00:24'!
path
	"returns the list of nodes to the root"
	^ self pathIn: OrderedCollection new.! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/10/2009 12:44'!
pathIn: aCollection 
	self parentNode ifNotNil: [
		(aCollection includes: self parentNode)
			ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

!GLMTreeMorphNodeModel methodsFor: 'printing' stamp: 'tg 9/9/2009 13:30'!
printOn: aStream
	aStream nextPutAll: 'a NodeModel with '.
	aStream nextPutAll: self item printString.! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 11/16/2009 06:46'!
rowMorphForColumn: aGlamourColumn
	^ (UITheme current
		newTextIn: World
		text: (self containerTree glamourPresentation column: aGlamourColumn valueFor: self item)) unlock; wrapFlag: true; yourself! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/30/2009 02:10'!
shouldBeDisplayed
	^ self shouldBeDisplayedByTags and: [ self shouldBeDisplayedByText ]! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/30/2009 02:15'!
shouldBeDisplayedByTags
	| nodeTags |
	self flag: 'it looks like this method does not really get called for children'.
"	self item mooseName = #'org::easymock' ifTrue: [self haltOnce ].
"	self containerTree tagsToFilterBy isEmpty ifTrue: [ ^ true ].
	self withContentsDo: [ :node | 
		nodeTags := self containerTree glamourPresentation tagsFor: node item to: #filter.
		(self containerTree tagsToFilterBy allSatisfy: [ :each | nodeTags includes: each ])
			ifTrue: [ ^ true ] ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/13/2009 02:10'!
shouldBeDisplayedByText
	self containerTree shouldFilterByTextInput ifFalse: [ ^ true ].
	self withContentsDo: 
		[ :node | 
		self flag: 'this should be delegated to the presentation
		and glamourValue should be used to include the entity ports'.
		(self containerTree glamourPresentation filterStrategy 
			value: self containerTree inputText asString
			value: node item) == true ifTrue: [ ^ true ] ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'VeronicaUquillas 11/19/2009 22:44'!
tagsColumn 
	| tags |
	tags := (self containerTree glamourPresentation tagsFor: self item to: #show).
	tags isEmpty ifFalse: [
		^ self buttonForTag: tags last filter: tags last ].
	^ RectangleMorph new! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:33'!
toggleFilteringByTag: aTag 
	self containerTree toggleFilteringByTag: aTag! !

!GLMTreeMorphNodeModel methodsFor: 'enumerating' stamp: 'tg 9/9/2009 13:42'!
withContentsDo: aBlock
	self flag: 'if the tree is infinite due to recursion, this might not stop'.
	aBlock value: self.
	self contents do: [:each | each withContentsDo: aBlock ]! !

MorphTreeModel subclass: #GLMExpanderTreeMorphModel
	instanceVariableNames: 'roots glamourExpander'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/2/2011 19:32'!
glamourExpander
	^ glamourExpander! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/2/2011 19:32'!
glamourExpander: anObject
	glamourExpander := anObject! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/4/2011 15:06'!
nodeModelFor: anObject
	^ GLMExpanderLabelNodeModel with: anObject in: self! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 14:07'!
roots
"	| filtered |"
	roots ifNil: [ self roots: self glamourExpander panes ].
	^ roots
"	filtered := roots select: [ :each | each shouldBeDisplayed ].
	((self shouldFilterByAmount and: [
		self amountToFilterBy < filtered size]) and: [
			filtered notEmpty]) ifTrue: [
		filtered := filtered first: self amountToFilterBy ].
	^ filtered"! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 13:52'!
roots: anObjectOrCollection
	roots := anObjectOrCollection isCollection 
		ifTrue: [ anObjectOrCollection collect: [:each | self nodeModelFor: each ] ]
		ifFalse: [ OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

MorphTreeModel subclass: #GLMTreeMorphModel
	instanceVariableNames: 'roots glamourPresentation childrenBlock onSelection displayFormat tagsToFilterBy announcer inputText amountToFilterBy defaultPageSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMTreeMorphModel commentStamp: 'alain.plantec 9/8/2009 15:22' prior: 0!
ClassTree new openOn: Collection
!

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 11/25/2010 13:21'!
allKeystrokeActions
	^ (self glamourPresentation allActions, self glamourPresentation allSelectionActions) select: [ :action | 
		action hasShortcut ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 11/18/2010 23:12'!
allMenuActions
	^ self glamourPresentation allSelectionActions select: [:action | action hasTitle ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/18/2010 23:59'!
amountToFilterBy
	^ nil "amountToFilterBy ifNil: [self glamourPresentation amountToShow]"! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 12:05'!
amountToFilterBy: aNumber 
	amountToFilterBy := aNumber! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:17'!
announce: anAnnouncement
	self announcer announce: anAnnouncement ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 2/17/2010 23:05'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:24'!
childrenBlock
	^ childrenBlock ifNil: [ childrenBlock := self glamourPresentation children isNil 
		ifFalse: [self glamourPresentation children] ifTrue: [OrderedCollection new] ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
childrenBlock: aBlock
	childrenBlock := aBlock ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/19/2010 00:12'!
defaultPageSize
	^ defaultPageSize! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/18/2010 23:54'!
defaultPageSize: anInteger
	defaultPageSize := anInteger! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:23'!
displayFormat
	^ displayFormat ifNil: [displayFormat := self glamourPresentation format]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
displayFormat: aBlock 
	displayFormat := aBlock ! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 00:11'!
doSearchOrFilter
	inputText isEmptyOrNil
		ifTrue: [ self resetInput ]
		ifFalse:[ 
			self glamourPresentation allowsFilter 
				ifTrue: [ self executeFilter ]
				ifFalse: [ self executeSearch ] ].
! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 01:25'!
executeFilter
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 8/18/2010 16:38'!
executeSearch
	| newSelection check |
	newSelection := OrderedCollection new.
	roots do: [ :each | 
		check := self glamourPresentation searchStrategy value: self inputText value: each item.
		check ifTrue: [newSelection add: each path]].
	newSelection isEmpty 
		ifFalse: [ self selection: (MorphTreeMorphMultipleSelection new selectedNodePathList: newSelection) ]
		ifTrue: [self selection: nil]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 2/28/2010 21:28'!
explicitSelection: anObject 
	"anObject is a domain object, not a Glamour related object"
	self glamourPresentation isMultiple 
		ifTrue: [ self explicitlySelectMultipleItems: anObject ]
		ifFalse: [ self explicitlySelectItem: anObject ]! !

!GLMTreeMorphModel methodsFor: 'private selecting' stamp: 'tg 2/28/2010 21:28'!
explicitlySelectItem: anObject 
	(self selectedItem notNil and: [self selectedItem = anObject]) ifTrue: [ ^ self ].
	(self selectedItem isNil and: [ anObject isNil ]) ifTrue: [ ^ self ].
	anObject isNil ifTrue: [self selection: nil].
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			each item = anObject ifTrue: [
				each expandParentPath.
				self selectNodePath: each path.
				^ self]]]! !

!GLMTreeMorphModel methodsFor: 'private selecting' stamp: 'tg 1/11/2010 22:02'!
explicitlySelectMultipleItems: aCollection 
	| newSelection collection|
	aCollection isNil ifTrue: [^ self].
	collection := aCollection isCollection ifTrue: [aCollection] ifFalse: [aCollection asOrderedCollection ].
	(self selection notNil and: [
		self selection selectedItemOrItemsOrNil = collection asOrderedCollection ]) ifTrue: [ ^ self ].
	newSelection := OrderedCollection new.
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			(collection includes: each item) ifTrue: [
				newSelection add: each path ]]].
	self selectAllNodePaths: newSelection! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 01:44'!
filteredRoots
	| filtered |
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation
	^ glamourPresentation! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/28/2009 01:24'!
inputText
	^ inputText ifNil: [inputText := '']! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 23:05'!
inputText: anObject
	inputText := anObject.
	self doSearchOrFilter! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 16:29'!
inputTextEnabled
	^ true! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 00:58'!
keyStroke: aCharacter from: aTreeMorph 
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aCharacter] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/29/2009 16:45'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:20'!
nodeModelFor: anObject
	^ (GLMTreeMorphNodeModel with: anObject) containerTree: self; yourself! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 12/29/2009 02:01'!
onDoubleClick
	self announcer announce: (GLMTreeMorphStrongSelectionChanged new strongSelectionValue: 
		(self selection ifNotNil: [self selection selectedItemOrItemsOrNil]))! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 00:11'!
resetInput
! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:00'!
resetTagsToFilterBy
	tagsToFilterBy := OrderedCollection new.
	self changed: #roots.! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 01:24'!
roots
	| filtered |
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	((self shouldFilterByAmount and: [
		self amountToFilterBy < filtered size]) and: [
			filtered notEmpty]) ifTrue: [
		filtered := filtered first: self amountToFilterBy ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:20'!
roots: anObjectOrCollection
	roots := anObjectOrCollection isCollection 
		ifTrue: [ anObjectOrCollection collect: [:each | self nodeModelFor: each ] ]
		ifFalse: [ OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 12/29/2009 01:57'!
selection: aSelection 
	self selection = aSelection ifTrue: [ ^ self ].
	super selection: aSelection.
	self announcer announce: (
			GLMTreeMorphSelectionChanged new 
				selectionValue: (aSelection ifNotNil: [aSelection selectedItemOrItemsOrNil]);
				selectionPathValue: self selectionPathItems;
				yourself)! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 11/29/2009 02:37'!
selectionPathItems
	^ self selectedNodePath isNil ifTrue: [nil] ifFalse: [self selectedNodePath collect: [:each | each item]]! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/30/2009 14:01'!
shouldFilterByAmount
	^ self amountToFilterBy notNil and: [self amountToFilterBy isZero not]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:29'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 11/13/2009 02:10'!
shouldFilterByTextInput
	^ self glamourPresentation allowsFilter and: [ self inputText notEmpty ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/13/2009 03:59'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 14:03'!
toggleAmountToFilterBy
	self amountToFilterBy notNil ifTrue: 
		[ self amountToFilterBy isZero 
			ifTrue: [ amountToFilterBy := self glamourPresentation amountToShow ]
			ifFalse: [ amountToFilterBy := 0 ].
		self changed: #roots ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 01:19'!
toggleFilteringByTag: aTag 
	(self shouldFilterByTag: aTag) 
		ifTrue: [self tagsToFilterBy remove: aTag ]
		ifFalse: [self tagsToFilterBy add: aTag].
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 12/31/2009 03:45'!
updateRoots
	roots := nil.
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:18'!
when: anAnnouncement do: aBlock
	self announcer when: anAnnouncement do: aBlock ! !

!ScrollBar methodsFor: '*glamour-morphic-renderer' stamp: 'TudorGirba 1/16/2011 13:10'!
glmAnimateValue: aNumber duration: anInteger
"	aNumber = value ifTrue: [^ self ]."
	anInteger <= 0 
		ifTrue: [ self setValue: aNumber ]
		ifFalse: [
			| startTime start end |
			startTime := Time millisecondClockValue.
			start := value "roundTo: scrollDelta".
			[ | delta |
			[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
				self setValue: (aNumber - start) * (delta / anInteger) + start.
				Processor yield ].
				self setValue: aNumber ]
					fork ]! !

RectangleMorph subclass: #GLMPaneScroller
	instanceVariableNames: 'sizing transform scrollBar paneCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:43'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: ''!
adoptPaneColor: aColor
	super adoptPaneColor: aColor.
	scrollBar adoptPaneColor: aColor! !

!GLMPaneScroller methodsFor: 'private' stamp: 'jorge.ressia 5/25/2009 16:25'!
basicUpdateSizing
	sizing := (self paneCount min: self maxPanes) max: 1! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
bounds: aRectangle
	super bounds: aRectangle.
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
computeMorphWidths
	| paneWidths widths |
	paneWidths := self paneWidthsToFit: self totalPaneWidth.
	widths := OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideOrShowScrollBar
	self isScrollable ifTrue: [self showScrollBar] ifFalse: [self hideScrollBar]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideScrollBar
	self removeMorph: scrollBar.
	self adjustPaneHeight.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'jorge.ressia 5/25/2009 16:29'!
initialize
	super initialize.
	self 
		color: Color white;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
	paneCount := 0.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: ''!
initializeScrollbar
	scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self resizeScrollBar.
! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'david_roethlisberger 3/18/2009 14:26'!
initializeTransform
	transform := TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
innerBounds
	| rect |
	rect := super innerBounds.
	^ self scrollBarIsVisible
		ifTrue: [rect withHeight: rect height - self scrollBarHeight - 1]
		ifFalse: [rect]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
isScrollable
	^ self leftoverScrollRange > 0! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
layoutPanes
	| widths rect |
	widths := self computeMorphWidths.
	rect := 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect := rect withWidth: w.
						m bounds: rect.
						rect := rect translateBy: (w@0)]
						
! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
layoutWidgets
	| inner outer |
	outer := super innerBounds.
	inner := self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom)
						corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!GLMPaneScroller methodsFor: 'configuration' stamp: 'david_roethlisberger 3/18/2009 15:05'!
maxPanes
	^2! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'jorge.ressia 5/25/2009 16:18'!
paneCount
	^ paneCount! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneHeight
	^ transform bounds height! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneWidthsToFit: limit
	| padded |
	padded := Array new: self paneCount.
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!GLMPaneScroller methodsFor: 'panes' stamp: 'tg 8/22/2010 22:40'!
popAndReplacePane: aMorph	
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.	
	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
popPane
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.
	self updatePanes.! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
pushPane: aMorph	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
resizeScrollBar
	| inner outer |
	outer := super innerBounds.
	inner := outer withHeight: outer height - self scrollBarHeight.
	scrollBar bounds: ((inner left @ inner bottom) corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
scrollBarHeight
	^ self theme scrollbarThickness! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollBarIsVisible
	^ submorphs includes: scrollBar! !

!GLMPaneScroller methodsFor: 'input events' stamp: ''!
scrollBarMenuButtonPressed: anObject! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollDeltaWidth
	^ 1! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'tg 8/22/2010 20:38'!
scrollToRight
"	(transform submorphs size + 1) / 2 > paneCount ifTrue: [ 
"		scrollBar glmAnimateValue: 1.0 duration: 200 "]"! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
separator
	^ BorderedSubpaneDividerMorph vertical
		adoptPaneColor: self paneColor;
		yourself! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:28'!
separatorWidth
	^3! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range := self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval := ((self innerBounds width) / self totalScrollRange) asFloat.
	value := (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
showScrollBar
	self scrollBarIsVisible ifTrue: [^ self].
	self resizeScrollBar.
	self addMorphFront: scrollBar.
	self adjustPaneHeight.
	! !

!GLMPaneScroller methodsFor: 'accessing' stamp: 'david_roethlisberger 3/18/2009 14:27'!
sizing
	^ sizing ifNil: [self updateSizing]! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'jorge.ressia 5/25/2009 16:40'!
updatePanes
	self basicUpdateSizing.
	self layoutPanes.
	self hideOrShowScrollBar.
	self setScrollDeltas.
	self scrollToRight! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
updateSizing
	| old |
	old := sizing.
	self basicUpdateSizing.
	sizing = old ifFalse: [self layoutPanes].
	^sizing! !

Announcer subclass: #GLMMorphicModel
	instanceVariableNames: 'glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicModel subclass: #GLMButtonModel
	instanceVariableNames: 'glamourAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:25'!
buttonLabel
	^ self glamourAction title! !

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:35'!
execute
	self glamourAction actOn: self glamourPresentation! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction
	^ glamourAction! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction: anObject
	glamourAction := anObject! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'TudorGirba 11/25/2010 13:20'!
allKeystrokeActions
	^ (self glamourPresentation allActions, self glamourPresentation allSelectionActions) select: [ :action | 
		action hasShortcut ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 11/19/2010 18:18'!
allMenuActions
	^ self glamourPresentation allSelectionActions select: [:action | action hasTitle ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'jre 7/31/2009 09:48'!
executeMenuAction: anAction
	self announce: (GLMMenuItemSelected action: anAction)! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation
	^ glamourPresentation! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMMorphicModel methodsFor: 'initialization' stamp: 'tg 8/4/2009 15:26'!
initialize
	super initialize.! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'TudorGirba 11/25/2010 13:21'!
keystroke: aChar from: aMorph
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aChar] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ].! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 9/8/2009 14:46'!
menu: aMenuMorph 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

GLMMorphicModel subclass: #GLMTextModel
	instanceVariableNames: 'text highlightSmalltalk highlightSmalltalkContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 11/12/2009 23:02'!
accept: aText notifying: anObject 
	aText asString withBlanksTrimmed ifEmpty: [^self].
	self text: aText.
	self changed: #text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk
	^ highlightSmalltalk! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk: anObject
	highlightSmalltalk := anObject! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext
	^ highlightSmalltalkContext! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext: anObject
	highlightSmalltalkContext := anObject! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 11/12/2009 22:58'!
keystroke: anEvent from: aMorph
	anEvent anyModifierKeyPressed ifTrue: [ super keystroke: anEvent keyCharacter from: aMorph ].
	self glamourPresentation text: self text.
! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:31'!
menu: aMorphMenu shifted: b
	^ self menu: aMorphMenu! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 5/14/2009 22:10'!
selectSilently: anIndex
	self changed: #selection! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/22/2010 13:14'!
selection
	^ self glamourPresentation selectionInterval ifNil: [1 to: 0]! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:42'!
shoutAboutToStyle: aPluggableShoutMorph
	self highlightSmalltalk ifFalse: [^ false].
	self highlightSmalltalkContext notNil ifTrue: [
		aPluggableShoutMorph classOrMetaClass: self highlightSmalltalkContext].
	^ true! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
text
	^text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 11/12/2009 23:04'!
text: aTextOrString
	text := aTextOrString.
	self glamourPresentation ifNotNil: [ :presentation | presentation text: text ]! !

Object subclass: #GLMDropListModel
	instanceVariableNames: 'list selectionIndex announcer glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 15:55'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 16:33'!
glamourPresentation

	^glamourPresentation! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 16:33'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/27/2010 17:34'!
list
	
	^list ifNil: [ list:= (self glamourPresentation displayValue 
									collect:[ :each| (self glamourPresentation formatedDisplayValueOf: each) asMorph ])]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 15:53'!
list: anObject
	list := anObject! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/27/2010 17:48'!
selectedItem
	"Answer the currently selected item or nil if none."

	^self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self glamourPresentation displayValue at: self selectionIndex]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/26/2010 14:45'!
selectionIndex

	^ selectionIndex ifNil:[ selectionIndex:= self glamourPresentation selectedIndex ]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/27/2010 17:49'!
selectionIndex: anObject
	selectionIndex := anObject.
	self announcer announce: (
			GLMDropDownListMorphSelectionChanged new 
				selectionValue: self selectedItem
				yourself)! !

Object subclass: #GLMMorphic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 6/15/2010 10:33'!
alignmentMorph: aCollectionOfMorphs
	"Answer a row-oriented AlignmentMorph holding the given collection"
	| morph |

	morph:= AlignmentMorph new
		listDirection: #leftToRight;
		borderWidth: 0;
		color: Color transparent;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		layoutInset: 1;
		wrapCentering: #center;
		cellPositioning: #center.
	aCollectionOfMorphs do: [ :each | morph addMorphBack: each].
	^morph! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/21/2011 10:11'!
containerMorph
	^ PanelMorph new
		layoutPolicy: ProportionalLayout new;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		yourself! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/21/2011 10:12'!
emptyMorph
	^ self containerMorph
		fillStyle: (SolidFillStyle color: Color veryLightGray slightlyLighter);
		yourself! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'tg 9/23/2010 20:04'!
grayRoundedButtonStyle: button morph: aMorph pressed: aBoolean
	button useRoundedCorners.
	(self isAlignmentMorph: aMorph)
		ifTrue: [
			aBoolean 
				ifTrue: [	aMorph lastSubmorph color: Color gray.
						button fillStyle: (button theme buttonSelectedFillStyleFor: button).
						button borderStyle: (button theme buttonSelectedBorderStyleFor: button) ]
				ifFalse:[	aMorph lastSubmorph color: Color white.
						button fillStyle: (button theme buttonNormalFillStyleFor: button).
						button borderStyle: (button theme buttonNormalBorderStyleFor: button) ] ]
		ifFalse: [			
			aBoolean 
				ifTrue: [	aMorph color: Color gray.
						button color: Color veryLightGray ]
				ifFalse:[	aMorph color: Color white.
						button color: Color lightGray ] ]
! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 11/19/2009 20:08'!
isAlignmentMorph: anObject

	^anObject isMemberOf: AlignmentMorph! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'VeronicaUquillas 6/15/2010 10:49'!
isGrayRoundedButton: aSymbol

	^aSymbol = #grayRoundedButton
		or:[ aSymbol = #default ]! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 11/19/2009 20:08'!
isImageMorph: anObject

	^anObject isMemberOf: ImageMorph! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'tg 9/3/2010 14:07'!
isWhiteRectangledButton: aSymbol
	^aSymbol = #whiteRectangledButton! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/20/2011 21:53'!
morphElement: anObject

	anObject isString
	ifTrue:[ ^StringMorph 
					contents: anObject 
					font: (LogicalFont 
						familyName: UITheme current buttonFont familyName
						pointSize: UITheme current buttonFont pointSize - 2) ].
	
	anObject isCollection 
	ifTrue: [ |row|
				row:= OrderedCollection new.
				anObject do: [ :e| row add: (self morphElement: e) ].
				^self alignmentMorph: row ].
				
	anObject isForm
	ifTrue:[ ^ImageMorph new newForm: anObject ].
	
	^self containerMorph! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/23/2010 19:59'!
styleButton: button morph: m pressed: aBoolean style: aSymbol
	(self isGrayRoundedButton: aSymbol)
		ifTrue:[ self grayRoundedButtonStyle: button morph: m pressed: aBoolean ].
	
	(self isWhiteRectangledButton: aSymbol)
		ifTrue:[ self whiteRectangledButtonStyle: button morph: m pressed: aBoolean ]! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/23/2010 21:17'!
togglingButtonLabelled: anObject pressed: aBoolean style: aSymbol
	| button oldLabel m |
	button := SimpleButtonMorph new.
	(oldLabel := button findA: StringMorph) ifNotNil: [ oldLabel delete ].
	m := self morphElement: anObject.
	button
		addMorph: m;
		borderColor: Color transparent.
	(self isAlignmentMorph: m)
		ifTrue:[ 
			button extent: (m width + 6 ) @ (m height + 6 ).
			m position: 3 @ 3 ]
		ifFalse:[ 
			(self isImageMorph: m)
				ifTrue: [ button extent: (m width + 6) @ (m height + 6) ]
				ifFalse:[ button extent: (m width + 6) @ (m height + 6) ].
			m position: 3 @ 3.	"button center - (m extent // 2)" ].
	self styleButton: button morph: m pressed: aBoolean style: aSymbol.
	m lock.
	^ button! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'VeronicaUquillas 10/1/2010 15:16'!
whiteRectangledButtonStyle: button morph: aMorph pressed: aBoolean

	button useSquareCorners.
	(self isAlignmentMorph: aMorph)
	ifTrue:[ 
		aBoolean 
		ifTrue: [ aMorph lastSubmorph color: Color white.
				      button borderColor: Color gray.
					button color: Color gray ]
		ifFalse:[ aMorph lastSubmorph color: Color black.
			            button borderColor: Color gray.
					button color: Color white ].
		button extent: aMorph width @ (aMorph height - 2) ]
	ifFalse:[			
		aBoolean 
		ifTrue: [ aMorph color: Color white.
			         button borderColor: Color gray.
				   button color: Color gray ]
		ifFalse:[ aMorph color: Color black.
			            button borderColor: Color gray.
					button color: Color white ].
		button extent: (aMorph width + 6) @ (aMorph height + 2) ]! !

Object subclass: #GLMMorphicIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicIcons classSide methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:45'!
form16x16FromContents: aByteArray 
	^ Form
	extent: 16@16
	depth: 32
	fromArray: aByteArray 
	offset: 0@0! !

!GLMMorphicIcons classSide methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:45'!
toolbarMenuForm
	^self form16x16FromContents: self windowMenuFormContents ! !

!GLMMorphicIcons classSide methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:46'!
toolbarMenuInactiveForm
	^self form16x16FromContents: self windowMenuInactiveFormContents ! !

!GLMMorphicIcons classSide methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:44'!
windowMenuFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 0 0 0 0 369098752 3556769792 3556769792 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 369098752 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!GLMMorphicIcons classSide methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:45'!
windowMenuInactiveFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 0 0 0 0 377520256 3565191296 3565191296 360282489 0 0 0 0 0 0 0 0 0 0 0 0 0 377520256 360282489 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

Object subclass: #GLMMorphicPresentationToolbarModel
	instanceVariableNames: 'renderer presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
presentation
	^ presentation! !

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
presentation: anObject
	presentation := anObject! !

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
renderer
	^ renderer! !

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
renderer: anObject
	renderer := anObject! !

Object subclass: #GLMMorphicWidgetRenderer
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWidgetRenderer commentStamp: '<historical>' prior: 0!
This is a helper class that is supposed to be subclassed for each rendering logic of a specific morph. For example, there will be a TreeRenderer, a TextRenderer etc!

GLMMorphicWidgetRenderer subclass: #GLMMorphicBrowserRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicBrowserRenderer subclass: #GLMMorphicAccumulatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/23/2011 00:12'!
render: aBrowser

	| tabs |
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
"	presentations size = 1 ifTrue: [ 
		^ self morph: (self render: presentations first) withTitleOrNilOf: aCompositePresentation ].
"	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	tabs announcer when: LazyTabPageChanged do: [:ann |  
		aBrowser activeEntity: ((aBrowser panes at: ann pageIndex) port: #entity) value ].
	tabs announcer when: LazyTabPageRemoved do: [:ann |  
		aBrowser removePaneIndex: ann pageIndex ].
	aBrowser panes do: [ :each | 
		tabs 
			addLazyPage: [ self renderPaneWithoutTitle: each ]
			label: (self titleOrIconOf: each presentations in: tabs) ].
	aBrowser 
		when: GLMPaneSelected
		do: [ :ann | 
			tabs selectedPageIndex: ann position ].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | 
			tabs addLazyPage: (self renderPaneWithoutTitle: ann pane) label: (self titleOrIconOf: ann pane presentations in: tabs).
			tabs selectedPageIndex: tabs pages size ].
	tabs selectedPageIndex: tabs pages size.
	^ tabs! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicExpanderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/12/2011 21:30'!
render: aBrowser
	| treeMorph treeModel |
	treeModel := GLMExpanderTreeMorphModel new glamourExpander: aBrowser.
	treeMorph := LazyMorphTreeMorph new.
	treeMorph
		makeLastColumnUnbounded;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: treeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		preferedPaneColor: Color white;	
		model: treeModel;
		nodeListSelector: #roots;
		columns: ( OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)).
	treeMorph vShowScrollBar.
	^ treeMorph buildContents
	
"	| morph scroll panel expander |
	panel := PanelMorph new.
	panel 
		fillStyle: Color transparent;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 2;
		cellInset: 2.
	scroll := GeneralScrollPane new.
	scroll 
		changeScrollerTableLayout;
		scrollTarget: panel.
	aBrowser panes do: [:each |
		expander := ExpanderMorph titleText: (each presentations titleValue ifNil: ['noname']).
		morph := GLMMorphicWidgetRenderer new	renderPaneWithoutTitle: each.
		morph 
			borderStyle: (UITheme current buttonSelectedBorderStyleFor: morph).
		expander addMorphBack: morph.
		panel addMorph: expander	].
	^ scroll"! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicFinderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/18/2011 13:26'!
addMorphFromObject: anObject toContainer: aContainerMorph
	| renderedMorph |
	renderedMorph := (self renderObject: anObject)
				vResizing: #spaceFill;
				hResizing: #rigid;
				minimumExtent: 200@10;
				extent: 200@10;
				yourself.
	aContainerMorph addMorphBack: renderedMorph.
	aContainerMorph addMorphBack: (EdgeGripMorph new
		width: ProportionalSplitterMorph splitterWidth;
		hResizing: #rigid; "not the default this time, vResizing is also #spaceFill by default"
		target: renderedMorph)! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/16/2011 13:02'!
render: aBrowser
	^ aBrowser fixedSize 
		ifTrue: [self renderWithFixedPanes: aBrowser]
		ifFalse: [self renderWithVariablePanes: aBrowser ]! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/16/2011 08:50'!
renderWithFixedPanes: aBrowser
	| container |
	container := GLMPaneScroller new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.
	aBrowser 
		when: GLMPaneRemoved
		do: [ :ann | container popPane.].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | container pushPane: (self renderObject: ann pane) ].
	aBrowser 
		when: GLMPaneReplaced
		do: [ :ann | 
			container popAndReplacePane: (self renderObject: ann newPane) ].
	aBrowser panes
		do: [ :each | container pushPane: (self renderObject: each) ].
	^ container! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:53'!
renderWithVariablePanes: aBrowser
	| container scrollPane |
	container := GLMMorphic containerMorph.
	container 
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap.
	scrollPane := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: container;
		yourself.
	aBrowser 
		when: GLMPaneRemoved
		do: [ :ann | 
			container removeMorph: container submorphs last.
			container removeMorph: container submorphs last
			 ].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | 
			self addMorphFromObject: ann pane toContainer: container.
			scrollPane hScrollbar glmAnimateValue: 1.0 duration: 2000 ].
	aBrowser 
		when: GLMPaneReplaced
		do: [ :ann | 
			container removeMorph: container submorphs last.
			container removeMorph: container submorphs last.
			self addMorphFromObject: ann newPane toContainer: container.
			scrollPane hScrollbar glmAnimateValue: 1.0 duration: 200 ].
	aBrowser panes do: [ :each | self addMorphFromObject: each toContainer: container ].
	^ scrollPane! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicStackerRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicStackerRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/22/2011 21:45'!
render: aBrowser
	| tabs |
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	aBrowser panes do: [ :each | 
		tabs 
			addLazyPage: [ self renderPaneWithoutTitle: each ]
			label: (self titleOrIconOf: each presentations in: tabs) ].
	tabs selectedPageIndex: 1.
	^ tabs! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicTabulatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:53'!
render: aBrowser
	| container |
	container := GLMMorphic containerMorph.
	aBrowser cell isRow 
		ifTrue: 
			[ self 
				renderCustomRow: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ]
		ifFalse: 
			[ self 
				renderCustomColumn: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ].

	^ container! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 1/20/2011 21:53'!
renderCustomColumn: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ 
				self 
					renderCustomRow: each
					ofPane: aPane
					inUI: (pane := GLMMorphic containerMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
					topFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
					leftFraction: 0 offset: 0;
					bottomFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
					rightFraction: 1 offset: 0;
					yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame bottomOffset: (aMorph submorphs atLast: 2) layoutFrame bottomOffset - aCell children last size. 
		aMorph submorphs last layoutFrame topOffset: aMorph submorphs last layoutFrame topOffset - aCell children last size. 
		aMorph submorphs last layoutFrame bottomOffset: aMorph submorphs last layoutFrame bottomOffset - aCell children last size.].
	aMorph addPaneSplitters! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 1/20/2011 21:53'!
renderCustomRow: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ self 
					renderCustomColumn: each
					ofPane: aPane
					inUI: (pane := GLMMorphic containerMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
				topFraction: 0 offset: 0;
				leftFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
				bottomFraction: 1 offset: 0;
				rightFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame rightOffset: (aMorph submorphs atLast: 2) layoutFrame rightOffset - aCell children last size. 
		aMorph submorphs last layoutFrame leftOffset: aMorph submorphs last layoutFrame leftOffset - aCell children last size. 
		aMorph submorphs last layoutFrame rightOffset: aMorph submorphs last layoutFrame rightOffset - aCell children last size.].
	aMorph addPaneSplitters! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicCompositeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicCompositeRenderer subclass: #GLMMorphicAccordionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccordionRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:55'!
render: aPresentation
	| presentations container expander |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	presentations size = 1 ifTrue: [ ^ self renderPresentation: presentations first ].
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		expander := self theme 
			newExpanderIn: container 
			label: (self titleOrIconOf: each in: container)
			forAll: {(self renderPresentation: each)}.
		container addMorphBack: expander.
		(aPresentation pane lastActivePresentation notNil and: [
			each title = aPresentation pane lastActivePresentation title ]) ifTrue: [
				expander expanded: true]].
	(aPresentation pane lastActivePresentation isNil and: [container submorphs notEmpty]) ifTrue: [
		container submorphs first expanded: true].
	^ container! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicTabbedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/23/2011 00:02'!
render: aPresentation

	| presentations tabs index |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	(presentations size = 1 and:[ presentations first hasTitleIcon not ])
		ifTrue: [ ^ self renderWithTitleOrNil: presentations first ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme buttonFont.
	tabs announcer when: LazyTabPageChanged do: [:ann |
		aPresentation pane lastActivePresentation: (aPresentation matchingPresentations at: (ann pageIndex)) ].
	presentations do: [ :each | 
"		tabs 
			addLazyPage: [ self renderPresentation: each ]
			label: (UITheme builder newRow: { (self titleOrIconOf: each in: tabs). (UITheme builder
			newCloseControlFor: nil
			action: [self halt]
			help: 'Close this tab')})
"
		tabs 
			addLazyPage: [ self renderPresentation: each ]
			label: (self titleOrIconOf: each in: tabs)
			].
	index := 1.
	presentations withIndexDo: [ :each :i | 
		aPresentation pane lastActivePresentation notNil and: [ 
			each title = aPresentation pane lastActivePresentation title ifTrue: [ 
				index := i ] ] ].
	tabs selectedPageIndex: index.
	aPresentation when: GLMPresentationUpdated do: [:ann |
		tabs clear.	
		presentations do: [ :each | 
			tabs 
				addLazyPage: [ self renderPresentation: each ]
				label: (self titleOrIconOf: each in: tabs) ].
			index := 1.
			presentations withIndexDo: [ :each :i | 
				aPresentation pane lastActivePresentation notNil and: [ 
					each title = aPresentation pane lastActivePresentation title ifTrue: [ 
						index := i ] ] ].
		tabs selectedPageIndex: index.].

	^ tabs! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicVerticallyStackedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicVerticallyStackedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:55'!
render: aPresentation
	| presentations container |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].	
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		container addMorphBack: (self renderWithTitle: each) ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDiffRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDiffRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:21'!
render: aPresentation
	| textMorph |
	textMorph := (DiffMorph from: aPresentation displayValue first to: aPresentation displayValue last)
"			onKeyStrokeSend: #keystroke:from: to: textModel;
"			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
"	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
"	^textMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicListingRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicListingRenderer subclass: #GLMMorphicListRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:53'!
render: aPresentation
	| treeModel container treeMorph textInput |
	treeModel := GLMTreeMorphModel new glamourPresentation: aPresentation.
	container := GLMMorphic containerMorph.
	treeMorph := self treeMorphFor: treeModel and: aPresentation.
	aPresentation allowsInput ifTrue: [
		textInput := self textInputFor: treeModel withHelpMessage: aPresentation helpMessage.
		treeMorph layoutFrame bottomOffset: -24.
		container addMorphBack: textInput ].
	container addMorphBack: treeMorph.
	self installActionsOnUI: treeModel fromPresentation: aPresentation.

	"When the morph changes, we want to update the glamour model"
	treeModel announcer on: GLMTreeMorphSelectionChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selection: ann selectionValue.
			aPresentation selectionPath: ann selectionPathValue] ].
	treeModel announcer on: GLMTreeMorphStrongSelectionChanged do: [ :ann | 
		aPresentation strongSelection: ann strongSelectionValue ].
	
	"When the glamour model changes, we want to update the morph"
	aPresentation when: GLMContextChanged do: [ :ann | 
			ann property = #selection ifTrue: [ 
				treeModel announcer suspendAllWhile: [
					treeMorph model explicitSelection: ann value ] ] ].
	aPresentation when: GLMPresentationUpdated do: [ :ann |
		treeMorph model updateRoots ].

	^ container! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'cyrille.delaunay 11/5/2010 13:03'!
textInputFor: treeModel withHelpMessage: helpStringMessage
	| textInput |
	textInput := self theme 
			newTextEntryIn: nil
			for: treeModel
			get: #inputText
			set: #inputText:
			class: String
			getEnabled: #inputTextEnabled
			help: helpStringMessage.
	textInput layoutFrame: (LayoutFrame 
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ -24 corner: 0 @ 0)).
	^ textInput! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'jannik.laval 10/23/2010 18:19'!
treeMorphFor: treeModel and: aPresentation
	| treeMorph columns |
	treeMorph := LazyMorphTreeMorph new.
	treeMorph
		makeLastColumnUnbounded;
		doubleClickSelector: #onDoubleClick;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: treeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		autoDeselection: aPresentation allowsDeselection;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	columns := aPresentation columns isEmpty 
		ifTrue: [ OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)]
		ifFalse: [
			aPresentation columns collect: [:each | 
				GLMMorphTreeColumn new 
					glamourColumn: each; 
					headerButtonLabel: (aPresentation titleValueOfColumn: each) 
					font: StandardFonts menuFont 
					target: nil 
					actionSelector: nil 
					arguments: #(); 
					yourself ].
		].
	treeMorph
		preferedPaneColor: Color white;	
		model: treeModel;
		nodeListSelector: #roots;
		columns: columns.
	aPresentation isMultiple 
		ifTrue: [treeMorph beMultiple] 
		ifFalse: [treeMorph beSingle].
	treeModel chunkSize: aPresentation amountToShow.
	treeMorph vShowScrollBar.
	^ treeMorph buildContents! !

GLMMorphicListingRenderer subclass: #GLMMorphicTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicListingRenderer subclass: #GLMMorphicTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTreeRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:18'!
render: aPresentation
	| container |
	container := super render: aPresentation.
	aPresentation shouldAllExpand ifTrue: [container submorphs first expandAll ].
	aPresentation shouldRootsExpand ifTrue: [container submorphs first expandRoots ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMagritteRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/13/2011 13:51'!
magritteMorphFrom: aMagrittePresentation
	| toShow description magritteMorph |
	toShow := aMagrittePresentation displayValue.
	description := (aMagrittePresentation magritteDescription glamourValue: toShow) copy.
	description morphClass: MASilentContainerMorph.
	magritteMorph := (description asMorphOn: toShow)
		addButtons;
		morph.
	magritteMorph
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutChanged.
	^ magritteMorph! !

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/16/2011 18:09'!
render: aMagrittePresentation
	| scrollPane | 
		.
	scrollPane := GeneralScrollPane new.
	scrollPane changeScrollerTableLayout.
	scrollPane scrollTarget: (self magritteMorphFrom: aMagrittePresentation).
	scrollPane layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 25 corner: 0 @ 0)).

	aMagrittePresentation when: GLMPresentationUpdated do: [:ann |
		scrollPane removeMorph: scrollPane submorphs last.
		scrollPane scrollTarget: (self magritteMorphFrom: aMagrittePresentation) ].

	^ scrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMondrianRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'TudorGirba 12/24/2010 01:13'!
mondrianCanvasFor: aPresentation in: aScrollPane 
	| canvas view |
	view := aPresentation view.
	view root interaction menu: [ :x | self menuIn: MenuMorph new for: aPresentation ].
	aPresentation renderOn: view.
	canvas := aPresentation canvas.
	canvas announcer
			when: MOElementSelection
			do: [ :ann | aPresentation selection: ann element model ].
	canvas announcer
			when: MOMouseEnter
			do: [ :ann | aPresentation status: ann element model ].
	canvas announcer
			when: MOMouseLeave
			do: [ :ann | aPresentation status: nil ].
	aPresentation when: GLMPresentationUpdated do: [:ann |
		aPresentation view: MOViewRenderer new.
		aScrollPane scroller removeMorph: aScrollPane scroller submorphs first.
		self mondrianCanvasFor: aPresentation in: aScrollPane ].
	aPresentation when: GLMContextChanged do: [ :ann | 
			ann property = #selection ifTrue: [ 
				canvas selected: (canvas root deepFindNodeWithEntity: ann value) ] ].
	aScrollPane scroller addMorph: canvas.	

	^ canvas! !

!GLMMorphicMondrianRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:22'!
render: aPresentation
	| canvasScrollPane |
	canvasScrollPane := ScrollPane new.
	self mondrianCanvasFor: aPresentation  in: canvasScrollPane.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	^ canvasScrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:53'!
render: aPane
	| container |
	container := GLMMorphic containerMorph.
	aPane when: GLMMatchingPresentationsChanged do: [ :ann | 
		container
			removeAllMorphs;
			addMorph: (self renderWithTitleOrNil: aPane presentations)
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			adoptPaneColor: container paneColor.
		self renderer window fullBounds.
		self renderer window refreshHorizontalScollbars ].
	container
		addMorph: (self renderWithTitleOrNil: aPane presentations)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: container paneColor.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicTextRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 12/1/2010 01:55'!
render: aPresentation
	| textMorph toShow textModel |
	toShow := aPresentation formatedDisplayValue.
	textModel := (GLMTextModel new)
						text: toShow;
						glamourPresentation: aPresentation;
						highlightSmalltalk: aPresentation highlightSmalltalk;
						highlightSmalltalkContext: aPresentation highlightSmalltalkContext.
	textMorph := aPresentation highlightSmalltalk 
			ifTrue: [self smalltalkTextMorphForModel: textModel]
			ifFalse: [self textMorphForModel: textModel].
	
	"this is a horrible hack: 
	because we cannot get the update of when the text changes from the morph,
	we get the reference to the mutable text object :) :)"
	textModel text: textMorph textMorph asText.
	self installActionsOnUI: textModel fromPresentation: aPresentation.
	aPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aPresentation textBlock: [ textMorph textMorph editor text ].
	aPresentation
		when: GLMPresentationUpdated
		do: [ :ann | 
			textModel text: aPresentation formatedDisplayValue.
			textModel changed: #text ].
	aPresentation
		when: GLMContextChanged
		do: [ :ann | 
			ann property = #selectionInterval
				ifTrue: [ textMorph setSelection: ann value ] ].
	^ textMorph! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 12/1/2010 01:55'!
smalltalkTextMorphForModel: textModel
	^ (PluggableShoutMorph
		on: textModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		onKeyStrokeSend: #keystroke:from: to: textModel;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Color white;
		yourself! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 12/1/2010 01:55'!
textMorphForModel: textModel
	^ (PluggableTextMorph
		on: textModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		onKeyStrokeSend: #keystroke:from: to: textModel;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Color white;
		yourself! !

!GLMMorphicWidgetRenderer classSide methodsFor: 'instance creation' stamp: 'tg 8/22/2010 20:20'!
render: aPresentation from: aRenderer
	^ self new 
		renderer: aRenderer;
		render: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
installActionsOnUI: aMorphicModel fromPresentation: aPresentation	 
	aMorphicModel when: GLMMenuItemSelected do: [ :ann | ann action actOn: aPresentation ].
	aMorphicModel when: GLMKeyStroke do: [ :ann | ann action actOn: aPresentation ].! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 11/20/2010 22:21'!
menuIn: aMenuMorph for: aPresentation
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	(aPresentation allActions select: [:each | each hasTitle and: [each hasIcon not]]) do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: action
			selector: #actOn:
			argument: aPresentation ].
	^ aMenuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
moreToolbarActions: noIconActions on: aBrowser
	| menuMorph |
	menuMorph := MenuMorph new.
	noIconActions do: [ :each | 
		menuMorph 
				add: each title
				target: each
				selector: #actOn:
				argument: aBrowser ].
	^ menuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/22/2011 21:46'!
morph: aMorph withTitleOf: aPresentation	
	| tabs |
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	tabs 
		addLazyPage: [aMorph]
		label: (self titleOrIconOf: aPresentation in: tabs)
		toolbar: (self renderToolbarForPresentation: aPresentation inMorph: aMorph).
	tabs selectedPageIndex: 1.
	^ tabs! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 9/10/2010 10:39'!
morph: aMorph withTitleOrNilOf: aPresentation
	(aPresentation hasTitle or: [aPresentation hasTitleIcon]) ifFalse: [^ aMorph ].
	^ self morph: aMorph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 20:17'!
render: aPresentation
	^ self subclassResponsibility ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/5/2011 23:47'!
renderObject: anObject
	^ self renderer render: anObject ! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:53'!
renderPaneWithoutTitle: aPane 
	| container |
	container := GLMMorphic containerMorph.
	aPane when: GLMMatchingPresentationsChanged do: [ :ann | 
		container
			removeAllMorphs;
			addMorph: (self renderPresentation: aPane presentations)
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			adoptPaneColor: container paneColor.
		self renderer window fullBounds.
		self renderer window refreshHorizontalScollbars ].
	container
		addMorph: (self renderPresentation: aPane presentations)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: container paneColor.
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/20/2011 21:53'!
renderPresentation: aPresentation
	| container offset dock presentationMorph |
	aPresentation allActions isEmpty ifTrue: [ 
		^ self renderObject: aPresentation ].
	container := GLMMorphic containerMorph.
	offset := 0.
	dock := self renderToolbarForPresentation: aPresentation inMorph: container.
	offset := dock minExtent y.
	container addMorph: dock fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ offset)).	
	presentationMorph := self renderObject: aPresentation.
	container 
		addMorph: presentationMorph 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ 0)).
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 11/20/2010 22:20'!
renderToolbarForPresentation: aPresentation inMorph: aMorph
	| dock tools buttons noIconActions |
	dock := aMorph theme newToolDockingBarIn: aMorph.
	buttons := (aPresentation allActions select: [:each | each hasIcon]) collect: [:each |
		(aMorph theme
			newButtonIn: aMorph for: each
			getState: nil
			action: #actOn:
			arguments: {aPresentation}
			getEnabled: nil
			label: (AlphaImageMorph new image: each icon)
			help: each title)
			valueOfProperty: #noBorder ifAbsentPut: [true];
			valueOfProperty: #noFill ifAbsentPut: [true];
			yourself ].
	noIconActions := aPresentation allActions select: [:each | each hasTitle and: [each hasIcon not]].
	tools := aMorph theme newToolbarIn: aMorph for: buttons.
	noIconActions isEmpty ifFalse: [
			| activeForm passiveForm menuButton | 
			activeForm := GLMMorphicIcons toolbarMenuForm.
			passiveForm := GLMMorphicIcons toolbarMenuInactiveForm.
			menuButton := MultistateButtonMorph new extent: activeForm extent.
			menuButton
				extent: activeForm extent;
						activeEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
						passiveEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
						activeEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
				passiveEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
				addUpAction: [ | menu |
						menu := self menuIn: MenuMorph new for: aPresentation.
						menu popUpEvent: self currentEvent in: aMorph world ];
				setBalloonText: 'Menu' translated.
			dock addMorphBack: menuButton.
			buttons isEmpty ifFalse: [dock addMorphBack: tools] ]
		ifTrue: [ dock addAllMorphs: buttons ].
	^ dock! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 11/26/2010 19:46'!
renderWithTitle: aPresentation
	| morph |
	morph := self renderPresentation: aPresentation.
	^ self morph: morph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 11/26/2010 19:46'!
renderWithTitleOrNil: aPresentation
	| morph |
	morph := self renderPresentation: aPresentation.
	^ self morph: morph withTitleOrNilOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 23:42'!
renderer
	^ renderer ifNil: [renderer := GLMMorphicRenderer new]! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'tg 8/22/2010 20:20'!
renderer: anObject
	renderer := anObject! !

!GLMMorphicWidgetRenderer methodsFor: 'factory' stamp: 'tg 8/23/2010 00:02'!
theme
	^ UITheme current! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
titleOrIconOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			self theme 
					newImageIn: container
					form: aPresentation titleIconValue ]
		ifFalse: [ aPresentation titleValue ifNil: [''] ].! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
titleOrIconOrNilOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			self theme 
					newImageIn: container
					form: aPresentation titleIconValue ]
		ifFalse: [ 
			aPresentation hasTitle 
				ifTrue: [ aPresentation titleValue ]
				ifFalse: [ nil ] ]! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicWindowRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 11/19/2010 22:17'!
render: aRenderable
	| dock offset bottomOffset statusbarMorph window |
	window := GLMSystemWindow new.
	window model: aRenderable.
	self setLabelOf: window for: aRenderable.
	offset := 0.
	bottomOffset := 0.
	(aRenderable allActions select: [:each | each hasIcon]) notEmpty ifTrue: [ 
		dock := self renderToolbarForPresentation: aRenderable inMorph: window.
		offset := dock minExtent y.
		window addMorph: dock fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ offset)) ].
	aRenderable hasStatusbar
		ifTrue: [ 
			statusbarMorph := self renderPaneWithoutTitle: aRenderable statusbarPane.
			bottomOffset := (0 - (LabelMorph contents: 'XXX') minHeight) * 1.2.
			window
				addMorph: statusbarMorph
				fullFrame: (LayoutFrame fractions: (0 @ 1 corner: 1 @ 1) offsets: (2 @ bottomOffset corner: -2 @ 0)) ].
	window
		addMorph: (self renderObject: aRenderable)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ bottomOffset)).
	(self theme isKindOf: UIThemeWatery)
		ifFalse: [ aRenderable colorValue ifNotNil: [ window paneColor: aRenderable colorValue ] ].
	aRenderable when: GLMPresentationUpdated do: [ :ann |
		self setLabelOf: window for: aRenderable. ].
	^ window! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:06'!
setLabelOf: window for: aRenderable
	window	setLabel: (self titleFor: aRenderable).! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:04'!
titleFor: aRenderable
	^ aRenderable titleValue ifNil: [ 'Glamorous Browser' ]! !

MorphTreeColumn subclass: #GLMMorphTreeColumn
	instanceVariableNames: 'glamourColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphTreeColumn methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 05:01'!
glamourColumn: aColumn
	glamourColumn := aColumn! !

!GLMMorphTreeColumn methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 05:49'!
rowMorphFor: aNodeMorph
	^ aNodeMorph rowMorphForColumn: glamourColumn.! !
